import os
import sys
import struct

k1 = 123
k2 = 456

def sub_258(a1, a2) :
    # Voir sstic 2020 Brice Berna solution ?
    v3 = 0

    while a2 :
        if ((a2 & 1) != 0) :
            v3 = v3 ^ a1
        a2 >>= 1
        if (a1 & 0x8000000000000000) :
            a1 = ((2 * a1) ^ 0x247F43CB7) & 0xffffffffffffffff
        else :
            a1 = (a1 * 2) & 0xffffffffffffffff

    return v3

def sign_u64(a1, a2) :
    # ((((a1 * k1) ^ a2) * k1) ^ k2) * k1
    # if a2 == 0 : 
    # (((a1 * k1) * k1) ^ k2) * k1
    # (((a1 * k1) * k1) * k1) ^ (k2 * k1)
    # (a1 * ((k1 * k1) * k1)) ^ (k2 * k1)
    # (a1 * k1**3) ^ (k2 * k1)

    # in galois field a1*k1^3 + a2*k1^2 + k1*k2

    tmp = sub_258(a1, k1) ^ a2
    tmp = sub_258(tmp, k1) ^ k2
    tmp = sub_258(tmp, k1)
    return tmp

def real(a1, a2) :
    import serial
    ser = serial.Serial(sys.argv[1], timeout=1)  # open serial port
    print(ser.name)         # check which port was really used
    ser.write(b'\x03')     # write a string
    ser.write(struct.pack('<Q', a1))
    ser.write(struct.pack('<Q', a2))
    res = ser.read(15)
    print(res)
    ser.close()             # close port
    return struct.unpack('<Q', res)[0]

def sign_data(data) :
    
    # pad if necessary
    if len(data) % 8 != 0 :
        pad = 8 - (len(data) % 8)
        for i in range(pad) :
            data += b'\x00'

    assert len(data) % 8 == 0
    res = 0
    for i in range(0, len(data), 8) :
        res = sign_u64(struct.unpack('<Q', data[i:i+8])[0], res)

    return res

def auth_pointer(ptr) :
    sig = sign_u64(ptr, 0)
    return ptr | (sig & 0xFFFF000000000000)


def main() :

    # interesting ?
    assert sub_258(0xcccccccccccccccc, 0xabababababababab) == sub_258(0xabababababababab, 0xcccccccccccccccc)
    assert sub_258(0xcccccccccccccccc, sub_258(0xabababababababab, 0xdddddddddddddddd)) == sub_258(sub_258(0xcccccccccccccccc, 0xabababababababab), 0xdddddddddddddddd)
    assert sub_258(0xcccccccccccccccc ^ 0xabababababababab, 0xdddddddddddddddd) == sub_258(0xcccccccccccccccc, 0xdddddddddddddddd) ^ sub_258(0xabababababababab, 0xdddddddddddddddd)
    val1 = struct.unpack('<Q', b'\x01anon\x00\x00\x00')[0]
    val2 = 0x0
    res = sign_u64(val1, val2)
    print('calculated', hex(res))

    val1 = 0x5555555589c0
    res = sign_u64(val1, val2)
    print('calculated', hex(res))
    # res2 = real(val1, val2)
    # print('real', hex(res2))
    # assert res == res2

    return

if __name__ == '__main__' :
    main()