import os
import sys
import json
from urllib.request import HTTPRedirectHandler

# from idc import *
# from idaapi import *

from ida_ua import create_insn
from ida_auto import auto_recreate_insn

g_start = 0x1140

def handler_x(bytecode, offset, label = ' '*6) :
    return offset

def handler_5d69(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} *(var_{op2:02x} + 4 * 0x{op3:02x}) = var_{op1:02x}'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_6027(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = *(var_{op2:02x} + 4 * 0x{op3:02x})'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_7858(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_dword(bytecode + offset)
    offset += 4

    dis = '{label} var_{op1:02x} = 0x{op2:x}'.format(label = label, op1 = op1, op2 = op2)
    print(dis)

    return offset

def handler_748f(bytecode, offset, label = ' '*6) :
    op1 = get_wide_word(bytecode + offset)
    offset += 2

    target = (offset + op1) & 0xffff
    dis = '{label} jmp label_{target:04x}'.format(label = label, target = target)
    print(dis)

    return offset

def handler_6063(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = var_{op2:02x} < var_{op3:02x}'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_3f99(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_word(bytecode + offset)
    offset += 2

    dis = '{label} jz var_{op1:02x} -> label_{target:04x}'.format(label = label, op1 = op1, target = offset + op2)
    print(dis)

    return offset

def handler_8293 (bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = var_{op2:02x} - var_{op3:02x}'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_78f8(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_0e -= 4 * {op1:x}'.format(label = label, op1 = op1)
    print(dis)

    return offset

def handler_7a05(bytecode, offset, label = ' '*6) :
    op1 = get_wide_dword(bytecode + offset)
    offset += 4

    dis = '{label} var_00 = call 0x{op1:08x}(var_00, var_01, var_02, var_03, var_04)'.format(label = label, op1 = g_start + op1)
    print(dis)

    return offset

def handler_5467(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = var_{op2:02x} + 4 * 0x{op3:02x}'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_63d9(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = var_{op2:02x} if 0x{op3:02x} == 0xff else var_{op2:02x} + var_{op3:02x}'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset


def handler_5e35(bytecode, offset, label = ' '*6) :

    dis = '{label} eax = var_00 ; ret'.format(label = label)
    print(dis)

    return -1

def handler_6584(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = *(uint8_t *)(var_{op2:02x} + var_{op3:02x})'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_87db(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_byte(bytecode + offset)
    offset += 1
    op3 = get_wide_byte(bytecode + offset)
    offset += 1

    dis = '{label} var_{op1:02x} = *(uint32_t *)(var_{op2:02x} + 4 * var_{op3:02x})'.format(label = label, op1 = op1, op2 = op2, op3 = op3)
    print(dis)

    return offset

def handler_6867(bytecode, offset, label = ' '*6) :
    op1 = get_wide_byte(bytecode + offset)
    offset += 1
    op2 = get_wide_word(bytecode + offset)
    offset += 2

    dis = '{label} jnz var_{op1:02x} -> label_{target:04x}'.format(label = label, op1 = op1, target = offset + op2)
    print(dis)

    return offset

g_vmHandlers = {
    "0x6867": {
        "dis": handler_6867
    },
    "0x87db": {
        "dis": handler_87db
    },
    "0x6584": {
        "dis": handler_6584
    },
    "0x5e35": {
        "dis": handler_5e35
    },
    "0x63d9": {
        "dis": handler_63d9
    },
    "0x5467": {
        "dis": handler_5467
    },
    "0x7a05": {
        "dis": handler_7a05
    },
    "0x78f8": {
        "dis": handler_78f8
    },
    "0x8293": {
        "dis": handler_8293
    },
    "0x3f99": {
        "dis": handler_3f99
    },
    "0x6063": {
        "dis": handler_6063
    },
    "0x748f": {
        "dis": handler_748f
    },
    "0x5d69": {
        "dis": handler_5d69
    },
    "0x6027": {
        "dis": handler_6027
    },
    "0x7858": {
        "dis": handler_7858
    }
}

def disasHandler(handler) :
    handler = int(handler, 16)
    print('### handler', hex(handler), '\n')
    addr = handler
    run = 1
    lines = []
    while run :

        # Whaaaaaat, generate_disasm_line will print garbage
        del_items(addr)
        create_insn(addr, None)

        disas = generate_disasm_line(addr, 0)
        lines.append(disas)

        if disas.startswith('ret') :
            run = 0
            qskljdl
        elif not disas.startswith('jmp') :
            # Get next instruction
            addr += get_item_size(addr)
        else :
            # jmp
            jmpType = get_operand_type(addr, 0)
            if jmpType == o_near :
                addr = get_operand_value(addr, 0)
            elif jmpType == o_reg :
                run = 0
            else :
                raise

    print('\n'.join(lines))

    return lines

    

def vm1(bytecode = 0x1338C, bytecode_offset = 0) :
    
    run = 1
    while run :
        insOffset = bytecode_offset
        handler = hex(get_wide_dword(bytecode + bytecode_offset) + g_start)
        bytecode_offset += 4

        if handler not in g_vmHandlers :
            lines = disasHandler(handler)
            g_vmHandlers[handler] = {}
            g_vmHandlers[handler]['raw'] = lines
            g_vmHandlers[handler]['sym'] = None
            break
        else :
            res = g_vmHandlers[handler]['dis'](bytecode, bytecode_offset, label = 'label_{:04x}'.format(insOffset))
            if res == -1 :
                run = 0
            else :
                bytecode_offset = res


    # create_insn(addr)
    # res = print_insn_mnem(addr)
    # print(res)

    # print(json.dumps(g_vmHandlers, indent = 4))

    return

# compress
# vm1()

# compress chunk
# vm1(0x13527)

# vm again
# vm1(0x130C0)

